#include "ListDirFromOffsetRespMsg.h"


fhgfs_bool ListDirFromOffsetRespMsg_deserializePayload(NetMessage* this, const char* buf,
   size_t bufLen)
{
   const char* logContext = "ListDirFromOffsetRespMsg deserialization";
   ListDirFromOffsetRespMsg* thisCast = (ListDirFromOffsetRespMsg*)this;

   size_t bufPos = 0;
   
   unsigned resultFieldLen;
   unsigned newServerOffsetBufLen;

   {  // newServerOffset
      if(!Serialization_deserializeInt64(&buf[bufPos], bufLen-bufPos,
         &thisCast->newServerOffset, &newServerOffsetBufLen) )
         return fhgfs_false;

      bufPos += newServerOffsetBufLen;
   }

   {  // result
      if(!Serialization_deserializeInt(&buf[bufPos], bufLen-bufPos, &thisCast->result,
         &resultFieldLen) )
         return fhgfs_false;

      bufPos += resultFieldLen;
   }

   {  // entryTypes
      if(!Serialization_deserializeIntCpyVecPreprocess(&buf[bufPos], bufLen-bufPos,
         &thisCast->entryTypesElemNum, &thisCast->entryTypesListStart, &thisCast->entryTypesBufLen) )
         return fhgfs_false;

      bufPos += thisCast->entryTypesBufLen;
   }

   {  // entryIDs
      if (!Serialization_deserializeStrCpyVecPreprocess(&buf[bufPos], bufLen-bufPos,
         &thisCast->entryIDsElemNum, &thisCast->entryIDsListStart, &thisCast->entryIDsBufLen) )
         return fhgfs_false;

      bufPos += thisCast->entryIDsBufLen;
   }

   {  // names
      if(!Serialization_deserializeStrCpyVecPreprocess(&buf[bufPos], bufLen-bufPos,
         &thisCast->namesElemNum, &thisCast->namesListStart, &thisCast->namesBufLen) )
         return fhgfs_false;

      bufPos += thisCast->namesBufLen;
   }

   if (unlikely((thisCast->entryTypesElemNum != thisCast->namesElemNum) ||
      (thisCast->namesElemNum != thisCast->entryIDsElemNum) ) ) // check for equal list lengths
   {
      printk_fhgfs(KERN_INFO, "%s: Sanity check failed (number of list elements does not match)!\n",
         logContext);
      return fhgfs_false;
   }


   return fhgfs_true;
}
